#include "Delegacias.h"
#include <stdio.h>


//#define WINDOWS_VS 1

#define _MAX(x,y) (x>y?x:y)

// informao esttica do problema
const int CDelegacias::delegaciaAlcance[] = { -1, 0, 1, 5, 13 };

// dados da instncia (estticos)
int CDelegacias::largura, CDelegacias::altura; 
int CDelegacias::populacao[MAX_ALTURA][MAX_LARGURA]; 
int CDelegacias::orcamento; 
int CDelegacias::proteger; 

// auxiliar
int CDelegacias::protegido[MAX_ALTURA][MAX_LARGURA]; // 1 - casa protegida 0 - desprotegida

CDelegacias::CDelegacias(void)
{
}

CDelegacias::~CDelegacias(void)
{
}

// Cria um objecto que e uma copia deste
TProcuraConstrutiva* CDelegacias::Duplicar(void)
{
	CDelegacias *clone=new CDelegacias;
	clone->delegacia = delegacia;
	clone->disponivel = disponivel;
	clone->protegidos = protegidos;
	return clone;
}

void CDelegacias::Copiar(TProcuraConstrutiva* objecto) {
	TProcuraConstrutiva::Copiar(objecto);
	delegacia = ((CDelegacias*)objecto)->delegacia;
	disponivel = ((CDelegacias*)objecto)->disponivel;
	protegidos = ((CDelegacias*)objecto)->protegidos;
}

// Coloca o objecto no estado inicial da procura
void CDelegacias::SolucaoVazia(void) {
	delegacia.Count(0);
	disponivel = orcamento;
	protegidos = 0;
}


// Coloca em sucessores a lista de objectos sucessores (sao alocados neste metodo e tem de ser apagados)
// O custo nao necessita de ser preenchido, caso seja sempre unitario
void CDelegacias::Sucessores(TVector<TProcuraConstrutiva*>&sucessores, TVector<int>&custo)
{
	// primeiro colocar deputados e explorar com menos delegacias, antes de explorar com mais delegacias

	if (disponivel > 0 && delegacia.Count() > 0) {
		// podemos adicionar deputados s delegacias
		// adicionar os deputados apenas aps a ltima delegacia sem deputados, para no repetir
		int ultimaDel = delegacia.Count() - 1;
		while (ultimaDel > 0 && delegacia[ultimaDel].alcance == 1)
			ultimaDel--;
		if (delegacia[ultimaDel].alcance == 1)
			ultimaDel--;
		if (++ultimaDel < delegacia.Count())
			for (int i = ultimaDel; i < delegacia.Count(); i++) // delegacia onde colocar deputados
				for (int j = 2; j <= 4 && disponivel >= delegaciaAlcance[j]; j++) {
					// no colocar deputados, se houver desperdcio (na borda), 
					// caso contrrio a delegacia seria colocada mais ao centro, sem perdas
					if (delegacia[i].zona.linha < j ||
						delegacia[i].zona.linha >= altura - j ||
						delegacia[i].zona.coluna < j ||
						delegacia[i].zona.coluna >= largura - j)
						continue; // no adicionado

					// se for a ltima delegacia, e sobrar oramento, apenas colocar se todas as delegacias tiverem deputados
					if (i == delegacia.Count() - 1 && disponivel - delegaciaAlcance[j] >= 1) {
						int saltar = 0;
						for (int k = 0; k < i; k++)
							if (delegacia[k].alcance == 1) {
								// cancelar sucessor, mais valia ter colocado 1 delegado nesta delegacia
								saltar = 1;
								break;
							}
						if (saltar)
							continue;
					}

					// colocar um nmero de deputados para ter alcence 2, 3 ou 4
					CDelegacias* sucessor = (CDelegacias*)Duplicar();
					sucessor->delegacia[i].alcance = j;
					sucessor->disponivel = disponivel - delegaciaAlcance[j];
					if (sucessor->TesteDeputados()) {
						// se aumentando, no se protege mais, ento no considerar (fica dominado pelo estado anterior)
						// tambm no pode alcanar outra delegacia, 
						// j que nesse caso fica dominado por um estado com as delegacias mais afastadas
						if (protegidos < sucessor->AtualizarProtecao() && 
							!sucessor->TesteAlcancaOutraDelegacia(i))
							sucessores.Add(sucessor);
						else
							delete sucessor;
					}
					else
						delete sucessor; // nem com as delegacias no mximo, consegue proteger
				}
	}


	if (disponivel>=4 && (delegacia.Count()==0 || 
		delegacia.Count()*4+disponivel==orcamento)) { 
		// podemos abrir uma delegacia e apenas colocar deputados no final
		// uma vez colocados deputados, no mais iremos abrir delegacias, para no duplicar estados
		// processar do centro para as bordas, ordem fixa que beneficia as delegacias no centro
		// Ateno: como no queremos repetio de pares por outra ordem, 
		//          a delegacia seguinte comea na posio da delegacia anterior

//#define _CENTRO_BORDAS 1
#ifdef _CENTRO_BORDAS
		for (int i = (delegacia.Count()==0?altura / 2:
			delegacia.Last().zona.linha);
			i < altura - 1 && i >= 1; // no colocar as delegacias nas bordas
			(i >= altura / 2 ?
				i -= 2 * (i - (altura / 2)) + 1 :
				i += 2 * ((altura / 2) - i))) 
			for (int j = ((delegacia.Count()==0 || i!=delegacia.Last().zona.linha) ? largura/2:
				delegacia.Last().zona.coluna);
				j < largura-1 && j >= 1; 
				(j >= largura / 2 ?
					j -= 2 * (j - (largura / 2)) + 1 :
					j += 2 * ((largura / 2) - j))) 
#else
		for (int i = (delegacia.Count() == 0 ? 1 :
			delegacia.Last().zona.linha);
			i < altura - 1; // no colocar as delegacias nas bordas
			i++)
			for (int j = ((delegacia.Count() == 1 || i != delegacia.Last().zona.linha) ? 1 :
				delegacia.Last().zona.coluna);
				j < largura - 1;
				j++)
#endif
			{
				if (delegacia.Count() > 0) {
					// verificar se esta delegacia  aps a delegacia anterior
					if (delegacia.Last().zona.linha == i &&
						delegacia.Last().zona.coluna == j)
						continue; // apenas  interessante posicionar aps a ltima delegacia
				}
				TDelegacia aux;
				aux.zona.linha = i;
				aux.zona.coluna = j;
				aux.alcance = 1; // de omisso fica s o xerife

				CDelegacias* sucessor = (CDelegacias*)Duplicar();
				sucessor->delegacia.Add(aux);
				sucessor->disponivel = disponivel - 4;
				// adicionar mesmo que no aumente a proteo, ainda pode aumentar o raio
				sucessor->AtualizarProtecao(); 
				// no pode alcanar outra delegacia, nesse caso o estado ficaria dominado
				if (!sucessor->TesteAlcancaOutraDelegacia(sucessor->delegacia.Count()-1))
					sucessores.Add(sucessor);
				else
					delete sucessor;
			}
	}

	TProcuraConstrutiva::Sucessores(sucessores,custo);
}

// > considerar que as delegacias esto fixas, 
//   e que todas recebem o mximo de delegados com a verba disponvel (se tiverem 0 deputados)
// > caso mesmo assim no seja possvel proteger a populao requerida, cortar
int CDelegacias::TesteDeputados()
{
	TVector<int> alcances;
	int alcanceMinimo = 1;
	int resultado;
	while (alcanceMinimo<4 && disponivel >= delegaciaAlcance[alcanceMinimo + 1])
		alcanceMinimo++;
	for (int i = 0; i < delegacia.Count(); i++) {
		alcances.Add(delegacia[i].alcance);
		if (delegacia[i].alcance == 1)
			delegacia[i].alcance = alcanceMinimo;
	}
	AtualizarProtecao();
	resultado = (protegidos >= proteger);
	for (int i = 0; i < delegacia.Count(); i++) 
		delegacia[i].alcance = alcances[i];
	return resultado;
}

// verifica se a delegacia i alcana outra delegacia (ou o inverso)
int CDelegacias::TesteAlcancaOutraDelegacia(int i)
{
	for (int j = 0; j < delegacia.Count(); j++) 
		if(j!=i && abs(delegacia[i].zona.linha - delegacia[j].zona.linha) <= _MAX(delegacia[i].alcance, delegacia[j].alcance) &&
			abs(delegacia[i].zona.coluna - delegacia[j].zona.coluna) <= _MAX(delegacia[i].alcance, delegacia[j].alcance))
			return 1;
	return 0;
}


void CDelegacias::Barra(int linha, int coluna)
{
	int protecaoMaxima = 0;
	if (linha >= 0)
		protecaoMaxima = protegido[linha][coluna];
	if (linha + 1 < altura && protecaoMaxima < protegido[linha + 1][coluna])
		protecaoMaxima = protegido[linha + 1][coluna];
	if (protecaoMaxima == 1)
		printf("  +--+ ");
	else if(protecaoMaxima>1)
		printf("  #==# ");
	else
		printf("   --  ");
}


// Escrever informacao de debug sobre o objecto currente
// (utilizar variavel TProcuraConstrutiva::debug para seleccionar o detalhe pretendido)
void CDelegacias::Debug(void)
{
	AtualizarProtecao();
	NovaLinha();
	for (int j = 0; j < largura; j++)
		Barra(-1, j);
	for (int i = 0; i < altura; i++) {
		NovaLinha();

		for (int j = 0; j < largura; j++) {
			if (protegido[i][j] > 0) {
				if (protegido[i][j] > 1) { // delegacia
					if (populacao[i][j] > 0)
						printf(" %dH%2dH ", protegido[i][j] - 2, populacao[i][j]);
					else
						printf(" %dH  H ", protegido[i][j] - 2);
				}
				else { // protegido, mas no h uma delegacia
					if (populacao[i][j] > 0)
						printf("  |%2d| ", populacao[i][j]);
					else
						printf("  |  | ");
				}
			}
			else { // no protegido
				if (populacao[i][j] > 0)
					printf("  |%2d| ", populacao[i][j]);
				else
					printf("  |  | ");

			}
		}
		NovaLinha();
		for (int j = 0; j < largura; j++)
			Barra(i, j);
	}
	NovaLinha();
	printf("Disponivel: %d [%d delegacias colocadas]", disponivel, delegacia.Count());
	NovaLinha();
	printf("Protegidos: %d/%d", protegidos, proteger);
	if (SolucaoCompleta()) {
		NovaLinha();
		printf("Solucao!");
	}
}

// Retorna verdade caso o estado actual seja um estado objectivo
bool CDelegacias::SolucaoCompleta(void)
{
	// verificar se a populao requerida est protegida
	return protegidos >= proteger;
}


void CDelegacias::CarregarInstancia(int id, int versao)
{
	static int populacao[10][MAX_ALTURA][MAX_LARGURA] = {
		// 5x5
{
{0,7,0,0,4},
{0,0,0,4,0},
{1,0,0,0,0},
{4,4,1,0,0},
{6,0,3,4,4},
},
{
{4,0,0,10,1},
{1,0,0,0,0},
{0,0,1,6,3},
{0,4,0,0,2},
{8,0,6,3,0},
},
		// 7x7
{
{0,8,0,4,5,10,0},
{0,4,0,7,0,4,0},
{0,2,4,2,0,0,2},
{0,7,0,1,2,0,0},
{2,4,0,0,3,0,2},
{0,4,0,0,3,0,0},
{2,0,0,0,0,0,0},
},
{
{0,0,1,0,7,0,1},
{0,1,4,0,0,0,4},
{0,0,0,0,2,0,0},
{3,1,0,8,5,7,7},
{0,4,0,3,0,0,0},
{0,0,0,3,2,4,2},
{0,8,3,6,3,0,0},
},
		// 9x9
{
{6,7,2,0,0,0,0,0,0},
{3,3,6,0,8,4,3,1,0},
{0,0,8,0,0,0,2,4,0},
{0,0,0,1,0,3,2,0,0},
{0,0,0,7,4,0,1,0,0},
{12,8,0,5,4,1,4,3,4},
{8,0,1,2,4,3,3,0,0},
{1,1,0,0,0,0,5,0,0},
{4,0,0,0,4,6,0,13,2},
},
{
{0,0,0,0,0,0,0,0,0},
{4,0,8,4,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0},
{0,0,0,0,3,0,0,1,0},
{0,3,0,0,0,0,0,0,0},
{0,0,0,1,1,0,0,3,0},
{0,0,2,4,0,0,0,1,0},
{0,2,0,0,8,0,4,3,10},
{0,0,3,0,0,4,0,0,0},
},
		// 11x11
{
{0,0,0,0,0,3,0,0,0,0,0},
{0,0,11,2,0,0,9,3,0,0,3},
{0,0,0,3,1,0,2,0,0,0,0},
{4,1,2,3,0,4,0,0,4,0,0},
{5,0,0,0,4,0,1,0,4,3,0},
{0,0,0,7,4,0,1,0,0,7,0},
{0,8,0,0,0,0,3,0,1,0,3},
{0,3,0,0,5,2,3,0,0,0,2},
{0,0,0,3,1,0,2,8,0,0,0},
{0,3,4,0,7,0,0,7,0,0,0},
{4,2,0,4,0,3,0,0,5,7,0},
},
{
{1,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0},
{0,0,10,10,0,0,0,4,5,0,0},
{0,4,1,0,8,0,0,0,0,0,5},
{8,0,0,0,0,0,6,0,0,0,0},
{0,0,0,0,13,0,0,0,2,0,3},
{0,0,0,0,4,0,0,0,0,1,0},
{0,0,0,0,0,0,0,0,0,0,0},
{0,0,4,0,0,0,0,3,0,0,0},
{4,1,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0},
},
		// 13x13
{
{2,4,0,0,6,7,3,4,0,0,3,0,1},
{0,0,2,0,3,0,0,6,0,0,8,11,3},
{0,3,0,8,0,0,2,0,0,0,0,0,4},
{2,0,0,0,0,0,0,0,0,3,2,0,0},
{0,6,0,8,0,3,0,0,0,0,0,0,1},
{0,3,0,2,0,0,9,0,0,0,0,5,6},
{1,9,4,0,0,2,4,0,0,0,3,2,0},
{2,3,0,4,0,0,0,6,2,0,1,0,3},
{0,0,0,0,0,6,0,0,0,2,2,0,8},
{7,2,4,2,0,0,6,4,1,0,0,0,7},
{0,0,0,11,0,0,0,0,3,4,0,9,0},
{0,0,0,0,1,4,3,4,0,0,0,3,11},
{0,0,4,7,7,0,0,2,0,2,5,0,1},
},
{
{0,0,1,4,0,0,9,0,0,0,12,0,1},
{0,0,0,0,0,0,0,0,0,1,0,0,0},
{1,0,0,0,0,0,2,0,0,2,0,0,0},
{0,0,0,0,0,9,4,0,0,0,6,0,0},
{0,6,9,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,1,6,10,0,1,4},
{0,3,0,0,0,1,0,0,0,0,0,2,0},
{0,0,0,1,3,0,0,0,0,9,0,0,0},
{9,0,0,3,3,0,0,0,0,3,4,0,0},
{0,1,4,0,0,0,0,0,0,5,0,1,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0},
{2,0,0,0,0,3,3,0,0,0,0,0,10},
{0,0,0,0,0,0,0,0,0,4,0,0,0},
}
	};
	static TZona dimensoes[] = { {5,5},{5,5}, {7,7},{7,7}, {9,9},{9,9},  {11,11},{11,11},  {13,13},{13,13}, };
	static int proteger[] = { 19, 21, 67, 59, 125, 57, 140, 93, 211, 125 }; // ltimas inst. existe soluo para 94,213,137
	static int orcamento[] = { 4,  4,  8,  8, 12, 12, 16,  16, 20,  20 };

	altura = dimensoes[id].linha;
	largura = dimensoes[id].coluna;
	for (int i = 0; i < altura; i++)
		for (int j = 0; j < largura; j++)
			CDelegacias::populacao[i][j] = populacao[id][i][j];
	CDelegacias::orcamento = orcamento[id];
	CDelegacias::proteger = proteger[id] + versao;
}

int CDelegacias::AtualizarProtecao()
{
	for (int i = 0; i < altura; i++)
		for (int j = 0; j < largura; j++)
			protegido[i][j] = 0;
	for (int k = 0; k < delegacia.Count(); k++)
		for (int i = delegacia[k].zona.linha - delegacia[k].alcance; 
			i <= delegacia[k].zona.linha + delegacia[k].alcance; 
			i++)
			if (i >= 0 && i < altura)
				for (int j = delegacia[k].zona.coluna - delegacia[k].alcance; 
					j <= delegacia[k].zona.coluna + delegacia[k].alcance; 
					j++)
					if (j >= 0 && j < largura)
						protegido[i][j] = 1;
	// colocar marca 2 para as delegacias
	for (int k = 0; k < delegacia.Count(); k++)
		protegido[delegacia[k].zona.linha][delegacia[k].zona.coluna] = 2 + delegacia[k].alcance;

	// atualizar protegidos
	protegidos = 0;
	for (int i = 0; i < altura; i++)
		for (int j = 0; j < largura; j++)
			if (protegido[i][j])
				protegidos += populacao[i][j];

	return protegidos;
}

